#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

bool isSq(long long x)
{
    long long y = sqrt(x);
    y = max(0LL, y - 2);
    for (long long i = y; i < y + 4; i++)
        if (i * i == x)
            return true;
    return false;
}

long long get_sq(long long x)
{
    long long y = sqrt(x);
    y = max(0LL, y - 2);
    for (long long i = y; i < y + 4; i++)
        if (i * i == x)
            return i;
}

int main()
{
    long long k;
    cin >> k;
    if (k >= 0 && isSq(k))
    {
        cout << get_sq(k);
        return 0;
    }
    if (k >= 0)
    {
        set<long long> s;
        for (long long i = 1; i * i <= k; i++)
        {
            if (k % i == 0)
            {
                s.insert(i);
                s.insert(k / i);
            }
        }
        long long ans = 1e18;
        for (auto &i : s)
        {
            for (auto &j : s)
            {
                if (i * j == k && (i + j) % 2 == 0)
                    ans = min(ans, (i + j) / 2);
            }
        }
        if (ans == 1e18)
            cout << "none";
        else
            cout << ans;
    }

    return 0;
}
