#include <iostream>
#include <vector>
#include <algorithm>
#include <bitset>

using namespace std;

vector<vector<int> > g;
vector<int> was;
vector<int> tps;

vector<pair<int, int> > dp;

int del;
bool bad;

void dfs1(int v)
{
    was[v] = 1;
    dp[v] = {1, 0};
    for (auto u : g[v])
    {
        if (was[u] == 0 && u != del)
        {
            dfs1(u);
            dp[v].first += dp[u].second;
            dp[v].second += max(dp[u].first, dp[u].second);
        }
    }
}

void topsort(int v)
{
    was[v] = 1;
    for (auto u : g[v])
    {
        if (del == u)
            continue;
        if (was[u] == 0)
            topsort(u);
        else
            bad = true;
    }
    tps.push_back(v);
}

int main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    int ans = 0;
    for (auto &i : a)
    {
        cin >> i;
        if (i != -1)
            i--;
    }

    if (n <= 20)
    {
        int ans = 0;
        vector<vector<int> > can(n, vector<int>(n, 1));
        for (int i = 0; i < n; i++)
        {
            if (a[i] != -1)
            {
                can[i][a[i]] = can[a[i]][i] = 0;
            }
        }
        for (int ma = 0; ma < (1 << n); ma++)
        {
            bool good = true;
            bitset<20> b(ma);
            for (int i = 0; i < n; i++)
            {
                for (int j = 0; j < n; j++)
                {
                    if (b[i] == 1 && b[j] == 1 && can[i][j] == 0)
                    {
                        good = false;
                        break;
                    }
                }
                if (!good)
                    break;
            }
            if (good)
                ans = max(ans, (int)b.count());
        }
        cout << ans;
        return 0;
    }


    g.resize(n);
    was.resize(n);
    dp.resize(n);
    for (int i = 0; i < n; i++)
    {
        if (a[i] != -1)
            g[a[i]].push_back(i);
    }

    if (n > 2000)
    {
        for (int i = 0; i < n; i++)
        {
            if (was[i] == 0)
            {
                dfs1(i);
                ans += max(dp[i].first, dp[i].second);
            }
        }
        cout << ans;
    }
    else
    {
        for (del = -1; del < n; del++)
        {
            tps.clear();
            bad = false;
            int res = 0;
            for (int i = 0; i < n; i++)
                if (was[i] == 0 && i != del)
                    topsort(i);
            fill(was.begin(), was.end(), 0);
            if (bad)
                continue;
            for (auto i : tps)
            {
                if (was[i] == 0)
                {
                    dfs1(i);
                    res += max(dp[i].first, dp[i].second);
                }
            }
            fill(was.begin(), was.end(), 0);
            ans = max(ans, res);
            res = 0;
        }
        cout << ans;
    }


    return 0;
}
