#include <iostream>
#include <vector>

using namespace std;

const int INF = 2 * 1e9;

int n, k;
vector<vector<int> > a;

bool check_mc(vector<int> &mc)
{
    vector<int> l(k, -INF), r(k, INF);
    for (int v = 0; v < n; v++)
    {
        int u = mc[v];
        if (u < v)
            continue;
        for (int i = 0; i < k; i++)
        {
            l[i] = max(l[i], min(a[v][i], a[u][i]));
            r[i] = min(r[i], max(a[v][i], a[u][i]));
        }
    }
    for (int i = 0; i < k; i++)
        if (l[i] > r[i])
            return false;
    return true;
}

bool slow_solve(vector<int> &mc)
{
    int v = -1;
    for (int i = 0; i < n; i++)
    {
        if (mc[i] == -1)
        {
            v = i;
            break;
        }
    }
    if (v == -1)
    {
        return check_mc(mc);
    }
    else
    {
        for (int i = v + 1; i < n; i++)
        {
            if (mc[i] == -1)
            {
                mc[v] = i;
                mc[i] = v;
                if (slow_solve(mc))
                    return true;
                mc[v] = -1;
                mc[i] = -1;
            }
        }
    }
    return false;
}

int main()
{
    cin >> n >> k;
    a.resize(n, vector<int>(k));
    for (auto &i : a)
        for (auto &j : i)
            cin >> j;
    if (n <= 10)
    {
        vector<int> mc(n, -1);
        if (slow_solve(mc))
        {
            cout << "YES" << '\n';
            for (int i = 0; i < n; i++)
            {
                if (mc[i] > i)
                    cout << i + 1 << ' ' << mc[i] + 1 << '\n';
            }
        }
        else
            cout << "NO";
    }



    return 0;
}
